package com.jiuqi.util;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.text.DecimalFormat;

public class DataUtil {
  public static final String DATA_NULL_VALUE = "--";
  
  public static final int PERCENT_DECIMAL = 1;
  
  public static int compare(Object o1, Object o2) {
    if (o1 == null && o2 == null)
      return 0; 
    if (o1 == null)
      return -1; 
    if (o2 == null)
      return 1; 
    double d1 = ((Double)o1).doubleValue();
    double d2 = ((Double)o2).doubleValue();
    if (d1 < d2)
      return -1; 
    if (d1 > d2)
      return 1; 
    return 0;
  }
  
  public static String getDigitValue(int demical, double src) {
    DecimalFormat df = new DecimalFormat();
    StringBuffer buff = new StringBuffer();
    buff.append("#");
    if (demical > -1) {
      if (demical > 0) {
        buff.append("0.");
      } else {
        buff.append("#");
      } 
      for (int i = 0; i < demical; ) {
        buff.append("0");
        i++;
      } 
    } else {
      buff.append("#.#####");
    } 
    df.applyPattern(buff.toString());
    return df.format(src);
  }
  
  public static boolean isDataValue(Object value) {
    if (value == null)
      return false; 
    if (value instanceof Double)
      return true; 
    if (value instanceof Integer)
      return true; 
    if (value instanceof Float)
      return true; 
    if (value instanceof Long)
      return true; 
    if (value instanceof Short)
      return true; 
    return false;
  }
  
  public static Double divide(Object o1, Object o2) {
    if (o1 == null)
      return new Double(0.0D); 
    if (o2 == null)
      return null; 
    if (isDataValue(o1)) {
      double v1 = ((Double)o1).doubleValue();
      double v2 = ((Double)o2).doubleValue();
      if (v2 == 0.0D)
        return null; 
      return new Double(v1 / v2);
    } 
    return null;
  }
  
  public static Object calcSum(Object[] values) {
    if (values == null || values.length == 0)
      return null; 
    Object validObj = null;
    for (int i = 0; i < values.length; i++) {
      if (values[i] != null) {
        validObj = values[i];
        break;
      } 
    } 
    if (validObj == null)
      return null; 
    if (validObj instanceof Double) {
      double returnValue = 0.0D;
      for (int j = 0; j < values.length; j++) {
        if (values[j] != null)
          returnValue += ((Double)values[j]).doubleValue(); 
      } 
      return new Double(returnValue);
    } 
    if (validObj instanceof Integer || validObj instanceof Long || validObj instanceof Short) {
      long returnValue = 0L;
      for (int j = 0; j < values.length; j++) {
        if (values[j] != null)
          returnValue += ((Integer)values[j]).intValue(); 
      } 
      return new Long(returnValue);
    } 
    if (validObj instanceof Float) {
      float returnValue = 0.0F;
      for (int j = 0; j < values.length; j++) {
        if (values[j] != null)
          returnValue += ((Float)values[j]).floatValue(); 
      } 
      return new Float(returnValue);
    } 
    return "";
  }
  
  public static int[] calcPlace(Object[] values) {
    if (values == null)
      return null; 
    if (values.length == 0)
      return new int[0]; 
    int[] returnPlace = new int[values.length];
    for (int i = 0; i < values.length; i++) {
      int p = 1;
      for (int j = 0; j < values.length; j++) {
        if (j != i)
          if (compare(values[j], values[i]) > 0)
            p++;  
      } 
      returnPlace[i] = p;
    } 
    return returnPlace;
  }
  
  public static boolean isLessthanOrEqualZeroData(Object value) {
    if (isNegativeData(value))
      return true; 
    if (!isDataValue(value))
      return true; 
    double d = ((Double)value).doubleValue();
    return (d == 0.0D);
  }
  
  public static boolean isNegativeData(Object value) {
    if (!isDataValue(value))
      return true; 
    double d = ((Double)value).doubleValue();
    return (d < 0.0D);
  }
  
  public static boolean isZeroData(Object value) {
    if (!isDataValue(value))
      return false; 
    double d = ((Double)value).doubleValue();
    return (d == 0.0D);
  }
  
  public static String[] calcPercent(Object[] values) {
    if (values == null)
      return null; 
    if (values.length == 0)
      return new String[0]; 
    String[] returnPercent = new String[values.length];
    for (int i = 0; i < values.length; i++) {
      if (isNegativeData(values[i])) {
        for (int j = 0; j < values.length; j++)
          returnPercent[j] = "--"; 
        return returnPercent;
      } 
    } 
    Object sumValue = calcSum(values);
    if (sumValue != null) {
      if (isLessthanOrEqualZeroData(sumValue)) {
        for (int k = 0; k < values.length; k++)
          returnPercent[k] = "--"; 
        return returnPercent;
      } 
      int specialPercentIndex = -1;
      double otherPercentValue = 0.0D;
      boolean notSpecialDealed = true;
      Object value = null;
      for (int j = 0; j < values.length; j++) {
        value = values[j];
        if (value == null) {
          returnPercent[j] = "--";
        } else if (!isZeroData(value) && notSpecialDealed) {
          specialPercentIndex = j;
          notSpecialDealed = false;
        } else {
          value = divide(value, sumValue);
          try {
            double percent = 100.0D * ((Double)value).doubleValue();
            String percentStr = getDigitValue(1, percent);
            returnPercent[j] = String.valueOf(percentStr) + "%";
            try {
              otherPercentValue += Double.parseDouble(percentStr);
            } catch (NumberFormatException numberFormatException) {}
          } catch (Exception exception) {}
        } 
      } 
      if (specialPercentIndex >= 0)
        returnPercent[specialPercentIndex] = String.valueOf(getDigitValue(1, 100.0D - otherPercentValue)) + "%"; 
    } 
    return returnPercent;
  }
}
